<html>
<head>
<title>Simple Equation</title>
</head>
<body>
<center>
<table width="80%">
  <tr>
    <td align="left">

<h3>Introduction</h3>

<p>One of the biggest obstacles to using mathematical expressions on the web is
that the user currently needs to worry about layout. Web users should not
have to learn a layout engine.</p>

<p>The class is built as a recursive parser. It is pretty easy to add
operations to the parser, but it will not scale to a huge set of operations.
That is OK, we want to keep things simple.  At some point a layout engine
may be required for a complexity level.  This is not a layout engine.</p>

<p>Currently, only graphical output is generated, but it is hoped that MathML
output can be generated automatically if the browser supports it instead of
the graphic.</p>

<h3>Demo:</h3>
<form method="post">
<?php
  if(isset($_POST['formula']))
    $formula = $_POST['formula'];
  else
  {
    $formulas[] = 'pi=int 0 1 {{16y-16}/{y^4-2y^3+4y-4}}dy';
    $formulas[] = 'pi=4 sum {k=1} n {(-1)^{k+1}/{2k-1}}';
    $formulas[] = 'pi=sum {k=1} inf {{3^k-1}/{4^k}zeta(k+1)}';
    $formulas[] = 'pi=sum {k=0} inf {{2(-1)^k 3^{1/2-k}}/{2k+1}}';
    $formulas[] = '1/4 pi sqrt 2=sum {k=1} inf ((-1)^{k+1} / {4k+1} + (-1)^{k+1}/{4k-3})';
    $formulas[] = '{pi-3}/4=sum {k=1} inf {(-1)^k/{2k(2k+1)(2k+2)}}';
    $formulas[] = 'pi^2/6=sum {k=1} inf {1/k^2}';
    $formulas[] = 'pi^2/8=sum{k=1}inf{1/(2k-1)^2}';
    $formulas[] = 'pi=3/4 sqrt 3+24 int 0 {1/4} {sqrt {x-x^2} dx}';
    $formulas[] = 'pi=sum {n=0} inf {{(n!)^2 2^{n+1}}/{(2n+1)!}}';
    $formulas[] = 'pi/2=sum{n=0}inf{{n!}/{(2n+1)!!}}';
    $formulas[] = '1/9 sqrt 3 pi=1/2 sum{i=1} inf {{(i!)^2}/{(2i+1)!}}';
    $formulas[] = 'pi/{5 sqrt{phi+2}}=1/2 sum{i=1}inf{{(i!)^2}/{phi^{2i+1}(2i+1)!}}';
    $formulas[] = 'pi=sum{n=0}inf{(4/{8n+1}-2/{8n+4}-1/{8n+5}-1/{8n+6})(1/16)^n}';
    $formulas[] = 'pi=int 0 1 {{16y-16}/{y^4-2y^3+4y-4}dy}';
    $formulas[] = 'pi=22/7-int 0 1 {{x^4 (1-x)^4}/{1+x^2}dx}';
    $formulas[] = 'pi=1/{2^6}sum{n=0}inf {(-1)^n/{2^{10n}}(-2^5/{4n+1}-1/{4n+3}+2^8/{10n+1}-2^6/{10n+3}-2^2/{10n+5}-2^2/{10n+7}+1/{10n+1})}';
    $formulas[] = 'pi^2=1/8 sum{k=0}inf {1/64^k(144/(6k+1)^2-216/(6k+2)^2-72/(6k+3)^2-54/(6k+4)^2+9/(6k+5)^2)}';
    $formulas[] = 'pi=4 tan^-1 1';
    $formulas[] = '1/pi=sum{n=0}inf{({2n}over n)^3 {42n+5}/{2^{12n+4}}}';
    $formula = $formulas[rand(0,count($formulas)-1)];
  }
?>
  <input type="text" name="formula" size="80" value="<?=$formula ?>" />
  <input type="submit" value="Go" />
</form>
<?php
  echo "<img src=\"draw.php?formula=".urlencode($formula)."\" />\n";
?>

<h3>Source:</h3>
<p><a href="http://www.eder.us/projects/simple_equation/simple_equation.tgz">Source</a> is available.</p>

<h3>Requirements</h3>

<p>Simple Equation requires PHP 4.2.0 or greater. Extension include: GD 2,
libpng and FreeType (2.1.4 or greater). Transparency will not work on all
browsers.</p>

<p>The standard Windows fonts symbol.ttf, timesi.ttf and times.ttf are
or equivalents required to render. These fonts can be changed in the render
function. Changing the fonts may require a change in the map also in that
function. <b>Note:</b> It is probably illegal to simply copy these from
Windows to use on Linux.</p>

<p>Design Science <a href="http://www.dessci.com/en/dl/fonts/">MathType Fonts</a>
provide eucsym.ttf to replace symbol.ttf, euclid.ttf to replace times.ttf, and
euclidi.ttf to replace timesi.ttf. Symlinks are recommended to map these font
files to the standard names. You should probably read the
<a href="http://www.dessci.com/en/support/eula/fonts/fontlic.htm">MathType Fonts License</a>.</p>

<h3>Functions:</h3>

<table border="1">
<?
   $formulas = array('f(x)'=>'function of x', "f'(x)"=>'derivative of x', 'f"(x)'=>'second derivative of x',
                'sqrt x'=>'Square root of x', 'root y x'=>'yth root of x', 'int _ _ x'=>'integral of x',
                'int 1 3 x'=>'integral from 1 to 3 of x', 'sum _ _ x'=>'summation of x',
                'sum 1 n x'=>'summation from 1 to n of x', 'x ^ y'=>'x raised to the yth power', 'x * y'=>'x times y',
                'bar x'=>'x bar', 'hat x'=>'x hat',
                'x . y'=>'x times y', 'x / y'=>'x divided by y', 'x + y'=>'x plus y', 'x - y'=>'x minus y','x_y'=>'x sub y',
                'forall x'=>'for all x',
		'exists x'=>'there exists an x', 'backepsilon'=>'back epsilon',	'therefore'=>'therefore', 'x ortho y'=>'x is orthogonal to y',
		'x le y'=>'x is less than or equal to y', 'x <= y'=>'x is less than or equal to y', 'x =< y'=>'x is less than or equal to y',
		'inf'=>'infinity', 'infinity'=>'infinity', 'leftright'=>'left right arrow', 'left'=>'left arrow', 'up'=>'up arrow',
		'right'=>'right arrow', 'down'=>'down arrow', 'pm'=>'plus or minus', '+-'=>'plus or minus',
		'x ge y'=>'x is greater than or equal to y', 'x >= y'=>'x is greater than or equal to y',
		'x => y'=>'x is greater than or equal to y', 'x times y'=>'x times y', 'x cross y'=>'x cross y', 'x prop y'=>'x is proportional to y',
		'partial / {partial x}'=>'derivative with respect to x', 'x dot y'=>'x dot y', 'x divide y'=>'x divided by y',
		'x div y'=>'x divided by y', 'x ne y'=>'x not equal to y', 'x <> y'=>'x not equal to y', 'x congr y'=>'x is congruent to y',
		'x approx y'=>'x is approximately y', 'aleph'=>'Aleph', 'im'=>'imaginary number', 'real'=>'real number',
		'wp'=>'p function (wp), Weierstrass p', 'x otimes y'=>'x otimes y', 'x oplus y'=>'x oplus y', 'null'=>'null or empty set',
		'empty'=>'null or empty set', 'x intersect y'=>'x intersection y', 'x union y'=>'x union y', 'x supset y'=>'x is a superset of y',
		'x supseteq y'=>'x is a proper superset of y', 'x notsubset y'=>'x is not a subset of y',
		'x propsubset y'=>'x is a proper subset of y', 'x subset y'=>'x is a subset of y', 'x element y'=>'x is an element of y',
		'x in y'=>'x is in y', 'x notelement y'=>'x is not an element of y', 'x notin y'=>'x is not in y', 'angle x'=>'the angle x',
		'nabla'=>'nabla', 'not x'=>'not x', 'x and y'=>'x and y', 'x or y'=>'x or y', 'x equiv y'=>'x is logically equivalent to y',
		'doubleleftright'=>'double left right arrow', 'doubleleft'=>'double left arrow', 'doubleup'=>'double up arrow',
		'doubleright'=>'double right arrow', 'x implies y'=>'x implies y', 'doubledown'=>'double down arrow','(x over y)'=>'x choose y');
  foreach($formulas as $formula=>$description)
    echo "<tr><td><b>$formula</b></td><td><img src=\"draw.php?formula=" . urlencode($formula) . "\"></td><td>$description</td></tr>\n";
?>
</table>

<h3>Parenthesis:</h3>

<p>visible ()<br />
invisible {}</p>

<h3>Greek letters:</h3>

<p>alpha is lowercase, Alpha is uppercase.</p>

<p>If you want to send actual e-mail, think about this:  My name is david and my domain is eder.us.</p>

</td>
</tr>
</table>
</body>
</html>
